﻿Imports System.ServiceModel
Imports System.ServiceModel.Channels

Module Module1

    Sub Main()
        Dim transportEndPoint As String

        Dim binding As New NetNamedPipeBinding()
        Dim factory As IChannelFactory(Of IDuplexSessionChannel) _
            = binding.BuildChannelFactory(Of IDuplexSessionChannel)(New BindingParameterCollection)
        factory.Open()
        __Out("factory: " & factory.State.ToString())

        With Nothing
            ' Connect1: 特定のエンドポイントに接続、新しいエンドポイントアドレスを受信する。
            Dim connectionChannel As IDuplexSessionChannel _
                = CreateOpenedChannel(factory, New EndpointAddress("net.pipe://localhost/IDuplexSessionChannel1/ConnectionInfo"))

            __Out("connectionChannel: " & connectionChannel.State.ToString())
            Debug.Assert(connectionChannel.State = CommunicationState.Opened)

            With Nothing
                ' Transport1
                Dim msg As Message = connectionChannel.Receive()
                transportEndPoint = msg.GetBody(Of String)()
                __Out("connectionChannel.Received: " & transportEndPoint)
                msg.Close()
            End With

            Try
                connectionChannel.Close()
            Catch ex As TimeoutException
                Throw
            Catch ex As CommunicationException
                Throw
            End Try
        End With

        With Nothing
            ' Connect2: 新しいエンドポイントアドレスで通信
            Dim transportChannel As IDuplexSessionChannel = CreateOpenedChannel(factory, New EndpointAddress(transportEndPoint))

            With Nothing
                ' Transport2-1
                __Out("transportChannel: " & transportChannel.State.ToString())
                Debug.Assert(transportChannel.State = CommunicationState.Opened)

                Dim msg As Message = transportChannel.Receive()
                __Out("transportChannel.Received1: " & msg.GetBody(Of String)())
                msg.Close()
            End With

            With Nothing
                ' Transport2-2
                Dim str As String = "MESSAGE"
                Dim msg As Message = Message.CreateMessage(binding.MessageVersion, transportEndPoint, str)
                '__Out("transportChannel.Send(): " & msg.GetBody(Of String)())    ' System.InvalidOperationException: "このメッセージは読み取られているため、操作をサポートできません。"
                transportChannel.Send(msg)
                __Out("transportChannel.Sent1: " & str)
                'msg.Close()
            End With

            With Nothing
                Dim msg As Message = transportChannel.Receive()
                __Out("transportChannel.Received2: " & msg.GetBody(Of String)())
                msg.Close()
            End With

            Try
                transportChannel.Close()
            Catch ex As TimeoutException
                Throw
            Catch ex As CommunicationException
                Throw
            End Try
        End With

        factory.Close()

        Console.WriteLine("")
        Console.WriteLine("Press <ENTER> to terminate the app.")
        Console.ReadLine()

    End Sub

    Public Function CreateOpenedChannel(factory As IChannelFactory(Of IDuplexSessionChannel), endpoint As EndpointAddress) As IDuplexSessionChannel
        Dim channel As IDuplexSessionChannel = Nothing

        Do Until Not IsNothing(channel) AndAlso channel.State = CommunicationState.Opened
            Try
                channel = factory.CreateChannel(endpoint)
                channel.Open()
            Catch ex As EndpointNotFoundException
                Throw
            Catch ex As TimeoutException
                __Out(ex.Message)
            Catch ex As CommunicationException
                Throw
            End Try
        Loop

        Debug.Assert(Not IsNothing(channel))
        Return channel
    End Function

    Public Sub __Out(message As String)
        Debug.WriteLine(My.Application.Info.AssemblyName & ": " & Now.ToString() & " " & message)
        Console.WriteLine(message)
    End Sub

End Module
